#Template(EIPTemplates,'Edit in place template'),family('ABC')
#!###############################################################################################
#!###############################################################################################
#!###############################################################################################
#Extension(FormToEIP,'Convert update form to EIP'), procedure
#Prompt('Listbox Control Number:',spin(@n10,1,9999)), %ListControlNum,REQ,default(1000)
#Prompt('Font Compensation factor:',spin(@s3,-999,999,1)), %FontCompNum,default('2'),REQ
#Prompt('Width Compensation factor:',spin(@s3,-999,999,1)), %WidthCompNum,default('0'),REQ
#Prompt('Number of browse columns:',spin(@n2,1,99,1)), %ProcessColumns,REQ

#Button('Instructions for use')
#Display(' Modified 17 Feb 2000'),at(10)
#Display(' Append the label of the listbox with a number separated'),at(10)
#Display(' by a comma - i.e.      ?List1,1000'),at(10)
#Display(' This number (1000) is the Listbox Control Number'),at(10)
#Display(' Set this window''s Imm attribute to FALSE'),at(10)
#Display(' Set Columns attribute to TRUE on listbox'),at(10)
#Display(' Make sure that the eip controls in this '),at(10)
#Display(' window are the first controls in the window.'),at(10)
#Display(' You need to re-order the fields and place the'),at(10)
#Display(' prompts and OK button at the end. Remove the '),at(10)
#Display(' cancel and help buttons. Remove the sheet and Tabs'),at(10)
#Display(' Ensure that the order and quantity of fields'),at(10)
#Display(' in the listbox must be identical to the order'),at(10)
#Display(' and quantity of fields in the update form.'),at(10)
#Display(' Turn off repositioning from ini file for this procedure'),at(10)
#Display(' and remove the resizing extension templates.'),at(10)
#EndButton

#Button('Open Source')
#Display('The contents of this file are subject to the'),at(10)
#Display('CoveComm Inc. Developers Open Source Public'),at(10)
#Display('License Version 1.0 (the "License"); you may'),at(10)
#Display('not use this product except in compliance with'),at(10)
#Display('the License. You may obtain a copy of the License'),at(10)
#Display('at http://www.clarionmag. com/common/dosl.html.'),at(10)
#Display('Software distributed under the License is'),at(10)
#Display('distributed on an "AS IS" basis, WITHOUT WARRANTY'),at(10)
#Display('OF ANY KIND, either express or implied. See the'),at(10)
#Display('License for the specific language governing rights'),at(10)
#Display('and limitations under the License. The Original Code'),at(10)
#Display('is copyright by James Cooke, released September 2,'),at(10)
#Display('1999. The Initial Developer of the Original Code is'),at(10)
#Display('James Cooke. All Rights Reserved.'),at(10)
#Button('Modifications')
#Display('S.Jordan: Fixed Hard coded %Listwidth variable(20 Feb)'),at(10)
#Display('S.Jordan: Fixed Hard coded window label(20 Feb)'),at(10)
#Display('S.Jordan: Width compensation factor introduced(20 Feb)'),at(10)
#EndButton
#EndButton

#AT(%LocalDataClassData)
EditInPlaceVariables GROUP,PRE(EIP)
FontSizeCompensator  SHORT        !number to compensate for incremental font creep
CurrentColumn        BYTE         !the cell the user clicked on
NumberColumns        BYTE         !total number of columns in the listbox
ListWidth            USHORT       !width of the listbox (needed for positioning form)
ListboxPos           SHORT        !width of the listbox (needed for positioning form)
InsertPos            SHORT        !Xpos of listbox, relative to entire screen
RowPos               SHORT        !Xpos of the clicked on cell, relative to entire screen
RowHeight            BYTE         !Height in pixels of the highlighted row
Font1                STRING(20)   !Listbox typeface (prop:font,1)
Font2                BYTE         !Listbox font size (prop:font,2)
Font3                LONG         !Listbox font color (prop:font,3)
Font4                LONG         !Listbox font style (prop:font,4)
ControlNum           SHORT        !Counter for internal operations
AccumPos             SHORT        !Accumulator for internal operations
Column               SHORT        !Counter for internal operations
ColumnPicture        CSTRING(20)  !Picture of current cell
ColumnWidth          BYTE         !Width of current cell
                     END
qColumns    Queue
ColumnPicture   CSTRING(20)
ColumnWidth     BYTE
End
#EndAt
#AT(%WindowManagerMethodCodeSection,'Ask','()'),priority(3800)
0{Prop:Text}=''
#EndAt

#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),priority(5600)
    0{prop:pixels}=1
    EIP:CurrentColumn   =   %ListControlNum{Prop:Column}
    EIP:RowHeight       =   %ListControlNum{prop:LineHeight}
    EIP:RowPos          =   %ListControlNum{prop:Ypos} +|
                            0{prop:ypos} + |
                            %ListControlNum{prop:HeaderHeight} +|
                            %ListControlNum{prop:LineHeight}+|
                            (%ListControlNum{prop:selected,1} * %ListControlNum{Prop:LineHeight}) - %FontCompNum
    EIP:InsertPos       =   (%ListControlNum{prop:Ypos} +|
                            0{prop:ypos} + |
                            %ListControlNum{prop:HeaderHeight} +|
                            %ListControlNum{prop:LineHeight}*2) - %FontCompNum
    EIP:ListboxPos      =   %ListControlNum{prop:Xpos} + 0{prop:xpos} + 3
    EIP:ListWidth       =   %ListControlNum{prop:width} - %WidthCompNum
    EIP:Font1           =   %ListControlNum{prop:font,1}
    EIP:Font2           =   %ListControlNum{prop:font,2}
    EIP:Font3           =   %ListControlNum{prop:font,3}
    EIP:Font4           =   %ListControlNum{prop:font,4}
    SELF.FirstField     =   choose(self.request=InsertRecord,1,EIP:CurrentColumn)

    clear(qColumns)
    LOOP EIP:Column = 1 to %ProcessColumns !Number of columns to process
        qColumns.ColumnPicture  =   %ListControlNum{PROPLIST:picture,EIP:Column}
        qColumns.ColumnWidth    =   %ListControlNum{PROPLIST:width,EIP:Column} +1
        add(qColumns)
    END
#EndAt
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),priority(8125)
  0{prop:pixels}          =   1

  Loop EIP:ControlNum=Firstfield() to LastField()
       If EIP:ControlNum{prop:type}<>create:entry  and |
          EIP:ControlNum{prop:type}<>create:button and |
          EIP:ControlNum{prop:type}<>create:list   and |
          EIP:ControlNum{prop:type}<>create:spin   and |
          EIP:ControlNum{prop:type}<>create:check  and |
          EIP:ControlNum{prop:type}<>create:option
          destroy(EIP:ControlNum)
       END
       If EIP:ControlNum{prop:type}=create:button then hide(EIP:ControlNum).
  end

0{prop:double}=0
0{prop:resize}=0
0{prop:text}=''
0{prop:status}=0
0{prop:gray}=0
0{prop:column}=1

If Self.Request         =   InsertRecord
    0{prop:YPos}        =   EIP:InsertPos
else
    0{prop:YPos}        =   EIP:RowPos
end

0{prop:height}          =   EIP:RowHeight
0{prop:XPos}            =   EIP:ListboxPos
0{prop:width}           =   EIP:ListWidth
! ====================================== OK =======================================
EIP:ControlNum=0
EIP:AccumPos = 0
EIP:Column = 0
Loop EIP:ControlNum=FirstField() to LastField()
     EIP:Column += 1
     EIP:ControlNum{prop:height} =   EIP:RowHeight
     EIP:ControlNum{prop:ypos}   =   0
     EIP:ControlNum{prop:font,1} =   EIP:Font1
     EIP:ControlNum{prop:font,2} =   EIP:Font2 - 1
     EIP:ControlNum{prop:font,3} =   EIP:Font3
     EIP:ControlNum{prop:font,4} =   EIP:Font4
     Get(qColumns,EIP:Column)
     EIP:ColumnPicture = qColumns.ColumnPicture
     EIP:ColumnWidth   = qColumns.ColumnWidth
     If EIP:ControlNum{prop:type}<>create:check              
        EIP:ControlNum{prop:Text}=EIP:ColumnPicture
     END
     EIP:ControlNum{prop:width}=EIP:ColumnWidth
     sum#+=EIP:ColumnWidth + 2
     EIP:ControlNum{prop:Xpos}=EIP:AccumPos
     EIP:AccumPos += EIP:ColumnWidth
END

! ====================================== OK =======================================
#EndAt